Index: /trunk/.classpath
===================================================================
--- /trunk/.classpath	(revision 944)
+++ /trunk/.classpath	(revision 945)
@@ -4,13 +4,5 @@
 	<classpathentry kind="src" output="bin/src" path="tests"/>
 	<classpathentry exported="true" kind="con" path="org.eclipse.jdt.junit.JUNIT_CONTAINER/3.8.1"/>
-
-	<!-- Use whatever Eclipse has as its default Java compiler -->
 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
-	<!-- Comment out the above and change to the following if you want Java 1.8 (and have taught
-	     Eclipse where Java 1.8 is on your file system -->
-	<!--
-	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/jdk1.8.0"/>
-	-->
-
 	<classpathentry kind="lib" path="releases/jars/activation.jar"/>
 	<classpathentry kind="lib" path="releases/jars/cobra.jar"/>
@@ -29,4 +21,5 @@
 	<classpathentry kind="lib" path="releases/jars/commons-cli-1.2.jar"/>
 	<classpathentry kind="lib" path="releases/jars/json-simple-1.1.1.jar"/>
+	<classpathentry kind="con" path="org.eclipse.pde.core.requiredPlugins"/>
 	<classpathentry kind="output" path="bin/src"/>
 </classpath>
Index: /trunk/.project
===================================================================
--- /trunk/.project	(revision 944)
+++ /trunk/.project	(revision 945)
@@ -11,7 +11,18 @@
 			</arguments>
 		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.pde.ManifestBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.pde.SchemaBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
 	</buildSpec>
 	<natures>
 		<nature>org.eclipse.jdt.core.javanature</nature>
+		<nature>org.eclipse.pde.PluginNature</nature>
 	</natures>
 </projectDescription>
Index: /trunk/META-INF/MANIFEST.MF
===================================================================
--- /trunk/META-INF/MANIFEST.MF	(revision 945)
+++ /trunk/META-INF/MANIFEST.MF	(revision 945)
@@ -0,0 +1,338 @@
+Manifest-Version: 1.0
+Bundle-ManifestVersion: 2
+Bundle-Name: Expeditee
+Bundle-SymbolicName: Expeditee
+Bundle-Version: 1.0.0.qualifier
+Bundle-ClassPath: Expeditee.jar,
+ releases/jars/activation.jar,
+ releases/jars/cobra.jar,
+ releases/jars/iText-2.1.3.jar,
+ releases/jars/jcommon-1.0.13.jar,
+ releases/jars/JEP.jar,
+ releases/jars/JFreeCharts.jar,
+ releases/jars/js.jar,
+ releases/jars/lobo.jar,
+ releases/jars/lobo-pub.jar,
+ releases/jars/mail.jar,
+ releases/jars/xercesImpl.jar,
+ releases/jars/jazzy-core.jar,
+ releases/jars/PDFRenderer-0.9.1.jar,
+ releases/jars/jgraphx.jar,
+ releases/jars/commons-cli-1.2.jar,
+ releases/jars/json-simple-1.1.1.jar
+Export-Package: .,
+ com.keypoint,
+ com.lowagie.text,
+ com.lowagie.text.factories,
+ com.lowagie.text.html,
+ com.lowagie.text.html.simpleparser,
+ com.lowagie.text.pdf,
+ com.lowagie.text.pdf.codec,
+ com.lowagie.text.pdf.codec.wmf,
+ com.lowagie.text.pdf.collection,
+ com.lowagie.text.pdf.crypto,
+ com.lowagie.text.pdf.draw,
+ com.lowagie.text.pdf.events,
+ com.lowagie.text.pdf.fonts,
+ com.lowagie.text.pdf.hyphenation,
+ com.lowagie.text.pdf.interfaces,
+ com.lowagie.text.pdf.internal,
+ com.lowagie.text.xml,
+ com.lowagie.text.xml.simpleparser,
+ com.lowagie.text.xml.xmp,
+ com.lowagie.tools,
+ com.mxgraph.analysis,
+ com.mxgraph.canvas,
+ com.mxgraph.costfunction,
+ com.mxgraph.generatorfunction,
+ com.mxgraph.io,
+ com.mxgraph.io.graphml,
+ com.mxgraph.layout,
+ com.mxgraph.layout.hierarchical,
+ com.mxgraph.layout.hierarchical.model,
+ com.mxgraph.layout.hierarchical.stage,
+ com.mxgraph.layout.orthogonal,
+ com.mxgraph.layout.orthogonal.model,
+ com.mxgraph.model,
+ com.mxgraph.reader,
+ com.mxgraph.resources,
+ com.mxgraph.shape,
+ com.mxgraph.sharing,
+ com.mxgraph.swing,
+ com.mxgraph.swing.handler,
+ com.mxgraph.swing.images,
+ com.mxgraph.swing.util,
+ com.mxgraph.swing.view,
+ com.mxgraph.util,
+ com.mxgraph.util.png,
+ com.mxgraph.util.svg,
+ com.mxgraph.view,
+ com.steadystate.css,
+ com.steadystate.css.dom,
+ com.steadystate.css.parser,
+ com.steadystate.css.parser.selectors,
+ com.sun.activation.registries,
+ com.sun.activation.viewers,
+ com.sun.mail.handlers,
+ com.sun.mail.iap,
+ com.sun.mail.imap,
+ com.sun.mail.imap.protocol,
+ com.sun.mail.pop3,
+ com.sun.mail.smtp,
+ com.sun.mail.util,
+ com.sun.pdfview,
+ com.sun.pdfview.action,
+ com.sun.pdfview.colorspace,
+ com.sun.pdfview.decode,
+ com.sun.pdfview.decrypt,
+ com.sun.pdfview.font,
+ com.sun.pdfview.font.res,
+ com.sun.pdfview.font.ttf,
+ com.sun.pdfview.font.ttf.resource,
+ com.sun.pdfview.function,
+ com.sun.pdfview.gfx,
+ com.sun.pdfview.pattern,
+ com.swabunga.spell.engine,
+ com.swabunga.spell.event,
+ com.swabunga.util,
+ images,
+ javax.activation,
+ javax.mail,
+ javax.mail.event,
+ javax.mail.internet,
+ javax.mail.search,
+ javax.mail.util,
+ org.apache.commons.cli,
+ org.apache.html.dom,
+ org.apache.wml,
+ org.apache.wml.dom,
+ org.apache.xerces.dom,
+ org.apache.xerces.dom.events,
+ org.apache.xerces.dom3.as,
+ org.apache.xerces.impl,
+ org.apache.xerces.impl.dtd,
+ org.apache.xerces.impl.dtd.models,
+ org.apache.xerces.impl.dv,
+ org.apache.xerces.impl.dv.dtd,
+ org.apache.xerces.impl.dv.util,
+ org.apache.xerces.impl.dv.xs,
+ org.apache.xerces.impl.io,
+ org.apache.xerces.impl.msg,
+ org.apache.xerces.impl.validation,
+ org.apache.xerces.impl.xpath,
+ org.apache.xerces.impl.xpath.regex,
+ org.apache.xerces.impl.xs,
+ org.apache.xerces.impl.xs.identity,
+ org.apache.xerces.impl.xs.models,
+ org.apache.xerces.impl.xs.opti,
+ org.apache.xerces.impl.xs.traversers,
+ org.apache.xerces.impl.xs.util,
+ org.apache.xerces.jaxp,
+ org.apache.xerces.jaxp.datatype,
+ org.apache.xerces.jaxp.validation,
+ org.apache.xerces.parsers,
+ org.apache.xerces.util,
+ org.apache.xerces.xinclude,
+ org.apache.xerces.xni,
+ org.apache.xerces.xni.grammars,
+ org.apache.xerces.xni.parser,
+ org.apache.xerces.xpointer,
+ org.apache.xerces.xs,
+ org.apache.xerces.xs.datatypes,
+ org.apache.xml.serialize,
+ org.expeditee,
+ org.expeditee.actions,
+ org.expeditee.agents,
+ org.expeditee.agents.mail,
+ org.expeditee.agents.wordprocessing,
+ org.expeditee.assets,
+ org.expeditee.assets.icons,
+ org.expeditee.assets.images,
+ org.expeditee.assets.resources.dict,
+ org.expeditee.assets.resources.documentation.calculatetest,
+ org.expeditee.assets.resources.documentation.demo,
+ org.expeditee.assets.resources.documentation.documentation,
+ org.expeditee.assets.resources.documentation.expediteetest,
+ org.expeditee.assets.resources.documentation.framesetthatdoesntexist,
+ org.expeditee.assets.resources.documentation.simpledoc,
+ org.expeditee.assets.resources.documentation.simpletest,
+ org.expeditee.assets.resources.documentation.simpletestsuite,
+ org.expeditee.assets.resources.documentation.tutorials,
+ org.expeditee.assets.resources.fonts.Amaranth,
+ org.expeditee.assets.resources.fonts.DejaVu,
+ org.expeditee.assets.resources.fonts.FontAwesome,
+ org.expeditee.assets.resources.fonts.Metamorphous,
+ org.expeditee.assets.resources.fonts.RobotoCondensed,
+ org.expeditee.assets.resources.framesets.exploratorysearch,
+ org.expeditee.assets.resources.framesets.javascript,
+ org.expeditee.assets.resources.framesets.overlayset,
+ org.expeditee.assets.resources.framesets.platonicforms,
+ org.expeditee.assets.resources.framesets.pong,
+ org.expeditee.assets.resources.framesets.webbrowser,
+ org.expeditee.assets.resources.images,
+ org.expeditee.assets.scripts.browserreadablemode,
+ org.expeditee.assets.style,
+ org.expeditee.greenstone,
+ org.expeditee.gui,
+ org.expeditee.gui.indirect.mouse,
+ org.expeditee.importer,
+ org.expeditee.io,
+ org.expeditee.io.flowlayout,
+ org.expeditee.items,
+ org.expeditee.items.MagneticConstraint,
+ org.expeditee.items.MagneticConstraint.Actions,
+ org.expeditee.items.MagneticConstraint.Utilities,
+ org.expeditee.items.widgets,
+ org.expeditee.items.widgets.charts,
+ org.expeditee.math,
+ org.expeditee.network,
+ org.expeditee.reflection,
+ org.expeditee.setting,
+ org.expeditee.settings,
+ org.expeditee.settings.experimental,
+ org.expeditee.settings.exploratorysearch,
+ org.expeditee.settings.folders,
+ org.expeditee.settings.network,
+ org.expeditee.settings.network.proxy,
+ org.expeditee.settings.templates,
+ org.expeditee.simple,
+ org.expeditee.stats,
+ org.expeditee.taskmanagement,
+ org.jfree,
+ org.jfree.base,
+ org.jfree.base.config,
+ org.jfree.base.log,
+ org.jfree.base.modules,
+ org.jfree.chart,
+ org.jfree.chart.annotations,
+ org.jfree.chart.axis,
+ org.jfree.chart.block,
+ org.jfree.chart.demo,
+ org.jfree.chart.editor,
+ org.jfree.chart.encoders,
+ org.jfree.chart.entity,
+ org.jfree.chart.event,
+ org.jfree.chart.imagemap,
+ org.jfree.chart.labels,
+ org.jfree.chart.needle,
+ org.jfree.chart.plot,
+ org.jfree.chart.plot.dial,
+ org.jfree.chart.renderer,
+ org.jfree.chart.renderer.category,
+ org.jfree.chart.renderer.xy,
+ org.jfree.chart.resources,
+ org.jfree.chart.servlet,
+ org.jfree.chart.title,
+ org.jfree.chart.urls,
+ org.jfree.chart.util,
+ org.jfree.data,
+ org.jfree.data.category,
+ org.jfree.data.contour,
+ org.jfree.data.function,
+ org.jfree.data.gantt,
+ org.jfree.data.general,
+ org.jfree.data.io,
+ org.jfree.data.jdbc,
+ org.jfree.data.resources,
+ org.jfree.data.statistics,
+ org.jfree.data.time,
+ org.jfree.data.time.ohlc,
+ org.jfree.data.xml,
+ org.jfree.data.xy,
+ org.jfree.date,
+ org.jfree.io,
+ org.jfree.layout,
+ org.jfree.resources,
+ org.jfree.text,
+ org.jfree.threads,
+ org.jfree.ui,
+ org.jfree.ui.about,
+ org.jfree.ui.about.resources,
+ org.jfree.ui.action,
+ org.jfree.ui.tabbedui,
+ org.jfree.util,
+ org.json.simple,
+ org.json.simple.parser,
+ org.lobobrowser.async,
+ org.lobobrowser.clientlet,
+ org.lobobrowser.context,
+ org.lobobrowser.gui,
+ org.lobobrowser.html,
+ org.lobobrowser.html.domimpl,
+ org.lobobrowser.html.gui,
+ org.lobobrowser.html.io,
+ org.lobobrowser.html.js,
+ org.lobobrowser.html.parser,
+ org.lobobrowser.html.renderer,
+ org.lobobrowser.html.style,
+ org.lobobrowser.html.test,
+ org.lobobrowser.io,
+ org.lobobrowser.js,
+ org.lobobrowser.main,
+ org.lobobrowser.protocol.res,
+ org.lobobrowser.protocol.vc,
+ org.lobobrowser.request,
+ org.lobobrowser.security,
+ org.lobobrowser.settings,
+ org.lobobrowser.store,
+ org.lobobrowser.ua,
+ org.lobobrowser.util,
+ org.lobobrowser.util.gui,
+ org.lobobrowser.util.io,
+ org.lsmp.djep.djep,
+ org.lsmp.djep.djep.diffRules,
+ org.lsmp.djep.groupJep,
+ org.lsmp.djep.groupJep.function,
+ org.lsmp.djep.groupJep.groups,
+ org.lsmp.djep.groupJep.interfaces,
+ org.lsmp.djep.groupJep.values,
+ org.lsmp.djep.jama,
+ org.lsmp.djep.matrixJep,
+ org.lsmp.djep.matrixJep.function,
+ org.lsmp.djep.matrixJep.nodeTypes,
+ org.lsmp.djep.mrpe,
+ org.lsmp.djep.rewrite,
+ org.lsmp.djep.rpe,
+ org.lsmp.djep.sjep,
+ org.lsmp.djep.vectorJep,
+ org.lsmp.djep.vectorJep.function,
+ org.lsmp.djep.vectorJep.values,
+ org.lsmp.djep.xjep,
+ org.lsmp.djep.xjep.function,
+ org.lsmp.djepExamples,
+ org.lsmp.djepJUnit,
+ org.mozilla.classfile,
+ org.mozilla.javascript,
+ org.mozilla.javascript.continuations,
+ org.mozilla.javascript.debug,
+ org.mozilla.javascript.jdk11,
+ org.mozilla.javascript.jdk13,
+ org.mozilla.javascript.optimizer,
+ org.mozilla.javascript.regexp,
+ org.mozilla.javascript.resources,
+ org.mozilla.javascript.serialize,
+ org.mozilla.javascript.tools,
+ org.mozilla.javascript.tools.debugger,
+ org.mozilla.javascript.tools.debugger.downloaded,
+ org.mozilla.javascript.tools.idswitch,
+ org.mozilla.javascript.tools.jsc,
+ org.mozilla.javascript.tools.resources,
+ org.mozilla.javascript.tools.shell,
+ org.mozilla.javascript.xml,
+ org.mozilla.javascript.xmlimpl,
+ org.nfunk.jep,
+ org.nfunk.jep.evaluation,
+ org.nfunk.jep.function,
+ org.nfunk.jep.type,
+ org.nfunk.jepexamples,
+ org.nfunk.jeptesting,
+ org.w3c.css.sac,
+ org.w3c.css.sac.helpers,
+ org.w3c.dom.css,
+ org.w3c.dom.html,
+ org.w3c.dom.html2,
+ org.w3c.dom.stylesheets,
+ org.w3c.dom.views,
+ org.xamjwg.platform,
+ properties,
+ test
Index: /trunk/build.properties
===================================================================
--- /trunk/build.properties	(revision 945)
+++ /trunk/build.properties	(revision 945)
@@ -0,0 +1,20 @@
+source.Expeditee.jar = src/,\
+                       tests/
+bin.includes = META-INF/,\
+               releases/jars/activation.jar,\
+               releases/jars/cobra.jar,\
+               releases/jars/iText-2.1.3.jar,\
+               releases/jars/jcommon-1.0.13.jar,\
+               releases/jars/JEP.jar,\
+               releases/jars/JFreeCharts.jar,\
+               releases/jars/js.jar,\
+               releases/jars/lobo.jar,\
+               releases/jars/lobo-pub.jar,\
+               releases/jars/mail.jar,\
+               releases/jars/xercesImpl.jar,\
+               releases/jars/jazzy-core.jar,\
+               releases/jars/PDFRenderer-0.9.1.jar,\
+               releases/jars/jgraphx.jar,\
+               releases/jars/commons-cli-1.2.jar,\
+               releases/jars/json-simple-1.1.1.jar,\
+               Expeditee.jar
Index: /trunk/src/org/expeditee/gui/indirect/mouse/IndirectMouseActions.java
===================================================================
--- /trunk/src/org/expeditee/gui/indirect/mouse/IndirectMouseActions.java	(revision 944)
+++ /trunk/src/org/expeditee/gui/indirect/mouse/IndirectMouseActions.java	(revision 945)
@@ -6,10 +6,10 @@
 		//Left Mouse
 		BACK, TDFC, FRAMENAMECLICK, FOLLOWLINK, EXECUTEACTION,
+		//Middle Mouse
+		NEWLINE, GROUPPICKUP, DETACHLINE, ANCHORFREEITEMS, DELETEITEMS,
 		//Right Mouse
 		CREATERECTANGLE, EXTENDLINE, MAKEGROUPCOPY, MAKECOPY, EXTRUDE, RUBBERBANDCOPY, 
-		RUBBERBANDCORNERCOPY, STAMP, MERGESINGLE, MERGETWO, MERGEGROUP,
-		//Middle Mouse
-		NEWLINE, GROUPPICKUP, DETACHLINE, ANCHORFREEITEMS, DELETEITEMS
-	}
+		RUBBERBANDCORNERCOPY, STAMP, MERGESINGLE, MERGETWO, MERGEGROUP
+	}//Where has properties gone?
 	
 	private static final int ACTIONQUANTITY = Action.values().length;