Index: /trunk/src/org/expeditee/items/widgets/RubbishBin.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/RubbishBin.java	(revision 981)
+++ /trunk/src/org/expeditee/items/widgets/RubbishBin.java	(revision 981)
@@ -0,0 +1,72 @@
+package org.expeditee.items.widgets;
+
+import java.awt.BorderLayout;
+import java.awt.Color;
+import java.awt.Dimension;
+import java.awt.Insets;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.io.File;
+import javax.swing.BorderFactory;
+import javax.swing.JButton;
+import javax.swing.JPanel;
+import javax.swing.border.EmptyBorder;
+
+import org.expeditee.gui.FrameMouseActions;
+import org.expeditee.gui.FreeItems;
+import org.expeditee.items.Item;
+import org.expeditee.items.Text;
+import com.kitfox.svg.app.beans.*;
+
+//When the Rubbish Bin Widget is clicked by any of the mouse buttons, whatever is currently being picked up by the mouse is destroyed
+public class RubbishBin extends InteractiveWidget{	
+		
+	public RubbishBin(Text source, String[] args){	
+		
+		//Controls how the widget is displayed
+		super(source, new JPanel(new BorderLayout()), 80, 80, 80, 80);	
+		JButton clicked = new JButton("");
+		clicked.setBorder(new EmptyBorder(0, 0, 0, 0));		
+		clicked.setBackground(Color.white);
+		
+		//Imports the SVG and displays it as the JButton image
+		SVGIcon icon = null;		
+		Dimension size = new Dimension(80, 80);
+		File f = new File("src/org/expeditee/assets/images/bin.svg");
+		icon = new SVGIcon();		
+		
+		icon.setSvgURI(f.toURI());		
+		icon.setUseAntiAlias(true);
+		icon.setScaleToFit(true);
+		icon.setPreferredSize(size);
+		clicked.setIcon(icon);
+		_swingComponent.add(clicked);	
+		this.setWidgetEdgeThickness(0.0f);
+		this.setWidgetEdgeColor(Color.white);
+		
+		clicked.addActionListener(new ActionListener() {
+	        public void actionPerformed(ActionEvent e) {
+	        	
+	           System.out.println("Ok Button clicked.");
+	           
+	        }          
+	     });		
+	}
+	public boolean ItemsLeftClickDropped() {
+		
+		//Find what the mouse was holding at the time and delete it
+		Item freeItems = FreeItems.getItemAttachedToCursor();
+		if( freeItems != null){
+			
+			FrameMouseActions.delete(freeItems);		
+			
+		}
+		return true;
+	}
+	
+	@Override
+	protected String[] getArgs() {
+		// TODO Auto-generated method stub
+		return null;
+	}	
+}
Index: /trunk/src/org/expeditee/items/widgets/Undo.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/Undo.java	(revision 981)
+++ /trunk/src/org/expeditee/items/widgets/Undo.java	(revision 981)
@@ -0,0 +1,60 @@
+package org.expeditee.items.widgets;
+
+import java.awt.BorderLayout;
+import java.awt.Color;
+import java.awt.Dimension;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.io.File;
+import javax.swing.BorderFactory;
+import javax.swing.JButton;
+import javax.swing.JPanel;
+import javax.swing.border.EmptyBorder;
+
+import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.FrameGraphics;
+import org.expeditee.items.Text;
+
+import com.kitfox.svg.app.beans.SVGIcon;
+
+//Creates a button that when pressed, restores the previous action
+public class Undo extends InteractiveWidget{
+
+	public Undo(Text source, String[] args){		
+		
+		//Controls how the widget is displayed		
+		super(source, new JPanel(new BorderLayout()), 80, 80, 80, 80);	
+		JButton clicked = new JButton("");
+		clicked.setBorder(new EmptyBorder(0, 0, 0, 0));		
+		clicked.setBackground(Color.white);
+		
+		//Imports the SVG and displays it as the JButton image
+		SVGIcon icon = null;		
+		Dimension size = new Dimension(120, 120);
+		File f = new File("src/org/expeditee/assets/images/undo.svg");
+		icon = new SVGIcon();		
+		
+		icon.setSvgURI(f.toURI());
+		icon.setUseAntiAlias(true);
+		icon.setScaleToFit(true);
+		icon.setPreferredSize(size);
+		clicked.setIcon(icon);
+		_swingComponent.add(clicked);
+		this.setWidgetEdgeThickness(0.0f);
+		this.setWidgetEdgeColor(Color.white);		
+		
+		clicked.addActionListener(new ActionListener() {
+	        public void actionPerformed(ActionEvent e) {
+	        	
+	           System.out.println("Undo Button Clicked.");
+	           DisplayIO.getCurrentFrame().undo();		     
+	        }          
+	     });		
+	}
+	
+	@Override
+	protected String[] getArgs() {
+		// TODO Auto-generated method stub
+		return null;
+	}	
+}