Index: trunk/src/org/expeditee/assets/resources/documentation/home/0.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources/documentation/home/0.exp	(revision 1011)
+++ trunk/src/org/expeditee/assets/resources/documentation/home/0.exp	(revision 1012)
@@ -1,19 +1,20 @@
-V 2
+V 7
 U davidb
 D 20Feb2014[13:20]
 M davidb
-d 14Apr2016[09:49]
+d 14Apr2016[10:36]
 Z
 
-S T 4
-s 14Apr2016[09:46.11]
+S T 5
+s 14Apr2016[10:31.43]
 d 0 0 0 100
-P 1630 67
+P 1618 61
 T @ItemTemplate
 Q 0
-H 5.0
+H 10.0
+N 20.0
 o davidb
 v S
-f Metamorphous_r32
+f Amaranth_r42
 t -1.0
 b 0.0
@@ -27,91 +28,23 @@
 Z
 
-ActiveTime:00:00:45
+ActiveTime:00:02:25
 DarkTime:00:00:00
-48:53:027 259 48 Md
-48:53:136 259 48 Mu
-48:53:793 75 46 Md
-48:53:808 75 46 Rd
-49:01:649 300 259 kA
-49:01:841 321 259 kC
-49:01:924 340 259 kH
-49:02:128 364 259 kN
-49:02:238 388 259 kO
-49:02:347 409 259 kR
-49:02:785 428 259 kR
-49:02:879 447 259 kI
-49:02:963 457 259 kG
-49:03:056 479 259 kH
-49:03:166 503 259 kT
-49:03:891 516 259 kShift
-49:04:155 516 259 kSemicolon
-49:06:856 524 259 kBackspace
-49:07:026 516 259 kBackspace
-49:07:166 503 259 kBackspace
-49:07:304 479 259 kBackspace
-49:07:445 457 259 kBackspace
-49:07:601 447 259 kBackspace
-49:07:742 428 259 kBackspace
-49:07:895 409 259 kBackspace
-49:08:047 388 259 kBackspace
-49:08:188 364 259 kBackspace
-49:08:344 340 259 kBackspace
-49:08:703 321 259 kBackspace
-49:08:926 300 259 kShift
-49:08:977 300 259 k2
-49:09:319 335 259 kA
-49:09:820 356 259 kN
-49:09:956 380 259 kC
-49:10:049 399 259 kH
-49:10:306 423 259 kO
-49:10:368 444 259 kR
-49:10:697 463 259 kR
-49:10:775 481 259 kI
-49:10:880 492 259 kG
-49:10:936 513 259 kH
-49:11:030 537 259 kT
-49:11:398 551 259 kShift
-49:11:601 551 259 kSemicolon
-49:11:788 559 259 kSpace
-49:12:629 569 259 k5
-49:15:694 417 248 Md
-49:15:787 417 248 Mu
-49:16:571 387 51 Md
-49:16:654 387 51 Mu
-49:18:470 1684 45 Md
-49:18:577 1684 45 Mu
-49:18:942 1677 76 Md
-49:19:036 1677 76 Mu
-49:19:489 1677 76 Md
-49:19:645 1666 79 Mu
-49:20:096 1519 96 Md
-49:20:205 1519 96 Mu
-49:21:830 1467 260 kShift
-49:21:862 1467 260 k2
-49:22:311 1484 260 kA
-49:22:957 1492 260 kN
-49:23:223 1501 260 kC
-49:23:317 1509 260 kH
-49:23:551 1518 260 kO
-49:23:629 1527 260 kR
-49:23:912 1533 260 kR
-49:23:974 1539 260 kI
-49:24:084 1544 260 kG
-49:24:162 1553 260 kH
-49:24:255 1562 260 kT
-49:24:255 1567 260 kR
-49:24:787 1573 260 kBackspace
-49:25:357 1567 260 kShift
-49:25:622 1567 260 kSemicolon
-49:25:778 1572 260 kSpace
-49:26:136 1576 260 k5
-49:27:638 1671 85 Md
-49:27:716 1671 85 Mu
-49:28:910 1779 50 Md
-49:29:016 1779 50 Mu
-49:29:750 1528 253 Md
-49:29:812 1528 253 Mu
-49:30:478 1791 55 Md
-49:30:572 1791 55 Mu
-49:31:995 1419 259 Ld
-49:32:057 1419 259 Lu
+36:22:999 1502 407 kA
+36:23:400 1525 407 kN
+36:23:604 1548 407 kC
+36:23:670 1565 407 kH
+36:23:790 1587 407 kO
+36:23:868 1609 407 kR
+36:24:115 1625 407 kT
+36:24:159 1640 407 kO
+36:24:249 1662 407 kP
+36:24:546 1684 407 kShift
+36:24:756 1684 407 kSemicolon
+36:25:395 1696 407 k2
+36:25:417 1717 407 k0
+36:26:991 1633 392 Md
+36:27:066 1633 383 Mu
+36:27:776 1716 48 Md
+36:27:832 1716 48 Mu
+36:28:653 1568 264 Ld
+36:28:711 1568 264 Lu
Index: trunk/src/org/expeditee/assets/resources/documentation/home/1.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources/documentation/home/1.exp	(revision 1011)
+++ trunk/src/org/expeditee/assets/resources/documentation/home/1.exp	(revision 1012)
@@ -1,7 +1,7 @@
-V 20
+V 38
 U davidb
 D 17Nov2015[09:35]
 M davidb
-d 14Apr2016[09:56]
+d 14Apr2016[10:49]
 Z
 
@@ -23,5 +23,5 @@
 d 70 70 0 100
 P 5 70
-e 100 100 39 100
+e 100 100 50 100
 Q 0
 R 5.0
@@ -35,6 +35,6 @@
 s 17Nov2015[09:35.54]
 d 70 70 0 100
-P 1903 70
-e 100 100 39 100
+P 989 70
+e 100 100 50 100
 Q 0
 H 5.0
@@ -77,5 +77,5 @@
 d 70 70 0 100
 P 5 237
-e 100 100 39 100
+e 100 100 50 100
 Q 0
 R 5.0
@@ -89,6 +89,6 @@
 s 17Nov2015[09:35.54]
 d 70 70 0 100
-P 1903 237
-e 100 100 39 100
+P 989 237
+e 100 100 50 100
 Q 0
 H 5.0
@@ -112,4 +112,125 @@
 h -1.0
 
+S P 340
+s 14Apr2016[10:24.00]
+d 70 70 0 100
+P 40 363
+e 100 100 50 100
+Q 0
+o davidb
+v S
+h 2.0
+l 350 353
+c 356 357
+
+S P 339
+s 14Apr2016[10:24.00]
+d 70 70 0 100
+P 982 363
+e 100 100 50 100
+Q 0
+o davidb
+v S
+h 2.0
+l 350 347
+c 356 354
+
+S T 358
+s 14Apr2016[10:24.20]
+d 0 0 0 100
+P 60 375
+T My Things:
+Q 0
+o davidb
+v S
+f Amaranth_r53
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+
+S T 336
+s 14Apr2016[10:23.23]
+d 0 0 0 100
+P 580 440
+T Pictures
+F Pictures1
+Q 0
+o davidb
+v S
+f Amaranth_r53
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+
+S T 335
+s 14Apr2016[10:23.00]
+d 0 0 0 100
+P 822 440
+T Music
+F Music1
+Q 0
+o davidb
+v S
+f Amaranth_r53
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+
+S T 337
+s 14Apr2016[10:23.39]
+d 0 0 0 100
+P 80 440
+T Profile
+Q 0
+o davidb
+v S
+f Amaranth_i53
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+
+S T 362
+s 14Apr2016[10:25.14]
+d 0 0 0 100
+P 273 440
+T Documents
+F Documents1
+Q 0
+o davidb
+v S
+f Amaranth_r53
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+
+S P 341
+s 14Apr2016[10:24.00]
+d 70 70 0 100
+P 40 472
+e 100 100 50 100
+Q 0
+o davidb
+v S
+h 2.0
+l 353 344
+c 357 355
+
+S P 338
+s 14Apr2016[10:24.00]
+d 70 70 0 100
+P 982 472
+e 100 100 50 100
+Q 0
+o davidb
+v S
+h 2.0
+l 347 344
+c 354 355
+
 Z
 
@@ -126,4 +247,16 @@
 s 18 17
 
+L 350 1
+s 339 340
+
+L 353 1
+s 340 341
+
+L 347 1
+s 338 339
+
+L 344 1
+s 341 338
+
 Z
 
@@ -140,8 +273,187 @@
 s 18 17
 
+C 356 3
+s 339 340
+
+C 357 2
+s 340 341
+
+C 354 2
+s 338 339
+
+C 355 3
+s 341 338
+
 Z
 
-ActiveTime:00:07:17
+ActiveTime:00:12:57
 DarkTime:00:20:51
-56:28:023 1079 637 Ld
-56:28:085 1079 637 Lu
+48:21:612 538 378 kCtrl
+48:22:099 551 407 kCtrl
+48:22:129 551 407 kCtrl
+48:22:161 551 407 kCtrl
+48:22:187 552 407 kCtrl
+48:22:221 554 406 kCtrl
+48:22:247 555 404 kCtrl
+48:22:276 556 402 kCtrl
+48:22:307 556 402 kCtrl
+48:22:335 556 402 kCtrl
+48:22:364 556 402 kCtrl
+48:22:399 557 401 kCtrl
+48:22:431 557 400 kCtrl
+48:22:455 557 398 kCtrl
+48:22:484 558 395 kCtrl
+48:22:513 558 393 kCtrl
+48:22:547 558 389 kCtrl
+48:22:572 558 389 kCtrl
+48:22:601 558 388 kCtrl
+48:22:632 558 388 kCtrl
+48:22:661 558 388 kCtrl
+48:22:690 558 388 kCtrl
+48:22:720 558 388 kCtrl
+48:22:750 558 388 kCtrl
+48:22:778 558 388 kCtrl
+48:22:808 558 388 kCtrl
+48:22:837 558 388 kCtrl
+48:22:866 558 388 kCtrl
+48:22:896 558 388 kCtrl
+48:22:924 558 388 kCtrl
+48:22:955 558 388 kCtrl
+48:22:985 558 388 kCtrl
+48:23:015 558 388 kCtrl
+48:23:043 558 388 kCtrl
+48:23:072 558 388 kCtrl
+48:23:102 558 388 kCtrl
+48:23:133 558 388 kCtrl
+48:23:162 558 388 kCtrl
+48:23:190 558 388 kCtrl
+48:23:221 558 388 kCtrl
+48:23:251 558 388 kCtrl
+48:23:280 558 388 kCtrl
+48:23:309 558 388 kCtrl
+48:23:337 558 388 kCtrl
+48:23:371 558 388 kCtrl
+48:23:402 558 388 kCtrl
+48:23:429 558 388 kCtrl
+48:23:455 558 388 Rd
+48:23:464 558 388 kCtrl
+48:23:474 558 388 Ld
+48:23:489 558 388 kCtrl
+48:23:519 558 388 kCtrl
+48:23:548 558 388 kCtrl
+48:23:576 558 388 kCtrl
+48:23:606 558 388 kCtrl
+48:23:636 558 388 kCtrl
+48:23:666 558 388 kCtrl
+48:23:696 558 388 kCtrl
+48:23:726 558 388 kCtrl
+48:23:755 558 388 kCtrl
+48:23:785 558 388 kCtrl
+48:23:815 558 388 kCtrl
+48:23:844 558 388 kCtrl
+48:23:873 558 388 kCtrl
+48:23:901 558 388 kCtrl
+48:23:930 558 388 kCtrl
+48:23:960 558 388 kCtrl
+48:23:990 558 388 kCtrl
+48:24:019 558 388 kCtrl
+48:24:050 558 388 kCtrl
+48:24:079 558 388 kCtrl
+48:24:108 558 388 kCtrl
+48:24:137 558 388 kCtrl
+48:24:167 558 388 kCtrl
+48:24:196 558 388 kCtrl
+48:24:226 558 388 kCtrl
+48:24:255 558 388 kCtrl
+48:24:286 558 388 kCtrl
+48:24:315 558 388 kCtrl
+48:24:347 558 388 kCtrl
+48:24:377 558 388 kCtrl
+48:28:218 983 496 Md
+48:28:325 983 496 Mu
+48:30:043 982 472 Md
+48:30:140 982 472 Mu
+48:44:216 162 441 Md
+48:44:317 162 441 Mu
+48:45:447 164 432 Md
+48:45:533 164 432 Mu
+48:46:190 350 439 Md
+48:46:293 350 439 Mu
+48:46:892 349 431 Md
+48:46:965 349 431 Mu
+48:47:584 601 441 Md
+48:47:685 601 441 Mu
+48:48:776 599 430 Md
+48:48:870 599 430 Mu
+48:49:677 862 441 Md
+48:49:773 862 441 Mu
+48:50:383 854 431 Md
+48:50:485 854 431 Mu
+48:51:223 659 449 kCtrl
+48:51:719 554 415 kCtrl
+48:51:739 548 412 kCtrl
+48:51:774 535 409 kCtrl
+48:51:808 529 407 kCtrl
+48:51:828 526 406 kCtrl
+48:51:859 518 405 kCtrl
+48:51:886 516 405 kCtrl
+48:51:917 516 405 kCtrl
+48:51:947 516 405 kCtrl
+48:51:975 516 405 kCtrl
+48:52:006 516 405 kCtrl
+48:52:035 516 405 kCtrl
+48:52:065 516 405 kCtrl
+48:52:095 519 403 kCtrl
+48:52:123 524 401 kCtrl
+48:52:152 528 399 kCtrl
+48:52:188 532 398 kCtrl
+48:52:215 536 397 kCtrl
+48:52:240 537 396 kCtrl
+48:52:272 538 395 kCtrl
+48:52:299 540 394 kCtrl
+48:52:333 542 391 kCtrl
+48:52:363 545 390 kCtrl
+48:52:388 546 389 kCtrl
+48:52:418 547 388 kCtrl
+48:52:447 547 387 kCtrl
+48:52:475 548 386 kCtrl
+48:52:506 548 386 kCtrl
+48:52:536 548 386 kCtrl
+48:52:565 548 386 kCtrl
+48:52:594 548 386 kCtrl
+48:52:625 548 386 kCtrl
+48:52:666 548 386 kCtrl
+48:52:697 548 386 kCtrl
+48:52:727 548 386 kCtrl
+48:52:758 548 386 kCtrl
+48:52:787 548 386 kCtrl
+48:52:800 548 386 Rd
+48:52:808 548 386 Ld
+48:52:814 548 386 kCtrl
+48:52:845 548 386 kCtrl
+48:52:874 548 386 kCtrl
+48:52:909 548 386 kCtrl
+48:52:933 548 386 kCtrl
+48:52:962 548 386 kCtrl
+48:52:992 548 386 kCtrl
+48:53:022 548 386 kCtrl
+48:53:051 548 386 kCtrl
+48:53:081 548 386 kCtrl
+48:53:110 548 386 kCtrl
+48:53:140 548 386 kCtrl
+48:53:169 548 386 kCtrl
+48:53:197 548 386 kCtrl
+48:53:227 548 386 kCtrl
+48:53:256 548 386 kCtrl
+48:53:287 548 386 kCtrl
+48:53:317 548 386 kCtrl
+48:53:345 548 386 kCtrl
+48:53:375 548 386 kCtrl
+49:04:560 638 236 Ld
+49:04:572 638 236 Rd
+49:06:631 478 525 Rd
+49:06:636 478 525 Md
+49:07:551 494 467 Ld
+49:07:562 494 467 Rd
+49:08:750 480 508 Rd
+49:08:756 480 508 Md
Index: trunk/src/org/expeditee/assets/resources/documentation/home/frame.inf
===================================================================
--- trunk/src/org/expeditee/assets/resources/documentation/home/frame.inf	(revision 1011)
+++ trunk/src/org/expeditee/assets/resources/documentation/home/frame.inf	(revision 1012)
@@ -1,1 +1,1 @@
-home2
+home1